#! /usr/bin/env python

import yaml

from mcenter.interfaces import *
from mcenter.drivers import *

def load(path):
    try:
        f = open(path)
        y = yaml.load(f)
        f.close()
        return y
    except:
        return {}

if __name__ == "__main__":
    server_config = load("etc/mcenter/server.yml")
    
    modes = {}
    for (k, v) in server_config['modes'].iteritems():
        config = load("etc/mcenter/%s.yml" % v)
        modes[k] = eval(v)(config)
    
    interfaces = []
    for i in server_config['interfaces']:
        config = load("etc/mcenter/%s.yml" % i)
        i = eval(i)(modes, config)
        interfaces.append(i)
        i.start()
    
    console = Console(modes)
    console.cmdloop()

